import classNames from "classnames";
import React, { useEffect } from "react";
import { EXITED, useControll, useMount, useTranstion } from "utils-hooks";
export var topLeft = "topLeft";
export var topRight = "topRight";
export var bottomLeft = "bottomLeft";
export var bottomRight = "bottomRight";
export function Notice(props) {
    var _a;
    var _b = props.prefixCls, prefixCls = _b === void 0 ? "xy-notice" : _b, className = props.className, style = props.style, children = props.children, _c = props.placement, placement = _c === void 0 ? topRight : _c, _d = props.closeBtn, closeBtn = _d === void 0 ? null : _d, _e = props.duration, duration = _e === void 0 ? 1500 : _e, onClose = props.onClose, onUnmount = props.onUnmount, id = props.id;
    var _f = useControll(props, "visible", "defaultVisible"), visible = _f[0], setVisible = _f[1], isControll = _f[2];
    var _g = useTranstion(visible, true), ref = _g[0], state = _g[1];
    var opening = state.indexOf("en") !== -1;
    var classString = classNames(prefixCls, className, "state-" + state, prefixCls + "-" + placement, (_a = {},
        _a[prefixCls + "-visible"] = opening,
        _a));
    function handleClose() {
        if (!isControll) {
            setVisible(false);
        }
        if (onClose) {
            onClose();
        }
    }
    useEffect(function () {
        if (state === EXITED && onUnmount) {
            onUnmount();
        }
    }, [state]);
    useMount(function () {
        var timeHandler;
        if (duration) {
            timeHandler = setTimeout(handleClose, duration);
        }
        return function () { return clearTimeout(timeHandler); };
    });
    return (React.createElement("div", { className: classString, style: style, id: id, ref: ref },
        React.createElement("div", { className: prefixCls + "-content" }, children),
        closeBtn && (React.createElement("a", { className: prefixCls + "-close", onClick: handleClose }, closeBtn))));
}
export default Notice;
//# sourceMappingURL=Notice.js.map