import * as tslib_1 from "tslib";
import classNames from "classnames";
import React, { useState, useRef } from "react";
import { usePortal, useMount } from "utils-hooks";
import Notice, { topRight } from "./Notice";
export function Notification(props) {
    var _a;
    var _b = props.prefixCls, prefixCls = _b === void 0 ? "xy-notification" : _b, className = props.className, _c = props.placement, placement = _c === void 0 ? topRight : _c, getContainer = props.getContainer, _d = props.offset, offset = _d === void 0 ? 24 : _d, getNoticeRef = props.getNoticeRef, bindNoticeRef = props.bindNoticeRef, _e = props.fixed, fixed = _e === void 0 ? true : _e;
    var renderProtal = usePortal("", getContainer)[0];
    var offsetSty = offset + "px";
    var top = placement.indexOf("top") !== -1;
    var reverse = placement.indexOf("bottom") !== -1;
    var classString = classNames(prefixCls, className, prefixCls + "-" + placement, (_a = {},
        _a[prefixCls + "-fixed"] = fixed,
        _a));
    var style = {
        top: top && offsetSty,
        bottom: !top && offsetSty
    };
    var _f = useState([]), notices = _f[0], setNotices = _f[1];
    var noticeRef = useRef();
    function close(id) {
        var config = notices.find(function (x) { return x.id === id; });
        if (config) {
            config.visible = false;
            setNotices(notices.slice());
        }
    }
    function add(config) {
        if (!config.id) {
            config.id = "notification-id-" + notices.length;
        }
        var cfg = Object.assign({ duration: 4500 }, config, { placement: placement, visible: true, onClose: function () { return noticeRef.current.close(cfg.id); } });
        if (reverse) {
            setNotices([cfg].concat(notices));
        }
        else {
            setNotices(notices.concat([cfg]));
        }
        return function () { return noticeRef.current.close(cfg.id); };
    }
    function remove(id) {
        if (notices.some(function (x) { return x.id === id; })) {
            var other = notices.filter(function (x) { return x.id !== id; });
            setNotices(other.slice());
        }
    }
    noticeRef.current = { add: add, close: close, remove: remove };
    if (bindNoticeRef) {
        bindNoticeRef.current = noticeRef.current;
    }
    useMount(function () {
        if (getNoticeRef) {
            getNoticeRef(noticeRef);
        }
    });
    return renderProtal(React.createElement("div", { className: classString, style: style }, notices.map(function (cfg) { return (React.createElement(Notice, tslib_1.__assign({}, cfg, { key: cfg.id, onUnmount: function () { return remove(cfg.id); } }))); })));
}
export default React.memo(Notification);
//# sourceMappingURL=Notification.js.map