var _a;
import React from "react";
import ReactDOM from "react-dom";
import { topLeft, topRight, bottomLeft, bottomRight } from "./Notice";
import Notification from "./Notification";
var noticeRefMap = (_a = {},
    _a[topLeft] = null,
    _a[topRight] = null,
    _a[bottomLeft] = null,
    _a[bottomRight] = null,
    _a);
export function noticePopup(config) {
    var placement = config.placement || topRight;
    var noticeRef = noticeRefMap[placement];
    var close;
    function handleGetNoticeRef(ref) {
        noticeRefMap[placement] = ref;
        // 延迟到Notification加载到DOM后, 再加入
        setTimeout(function () {
            close = ref.current.add(config);
        }, 100);
    }
    if (noticeRef && noticeRef.current) {
        return noticeRef.current.add(config);
    }
    else {
        // 创建
        var div_1 = document.createElement("div");
        document.body.appendChild(div_1);
        ReactDOM.render(React.createElement(Notification, { placement: placement, getContainer: function () { return div_1; }, getNoticeRef: handleGetNoticeRef }), div_1);
        return function () {
            if (close) {
                close();
            }
        };
    }
}
//# sourceMappingURL=Popup.js.map